



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>NumPy基础：数组和矢量计算</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">NumPy基础：数组和矢量计算</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-23 13:32:40 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>今天被老板fire了，还是继续抄书吧，安抚我受伤的小心脏。知识还是得慢慢积累，一步一个脚印，这样或许才是最快的捷径。</p>
<p>------2015-2-16------------------------------------------------------------------</p>
<ul><li><strong>NumPy的ndarray:一种多维数组对象</strong></li></ul>
<p>NumPy一个重要的特点就是N维数组对象（ndarray），该对象是一个快速灵活的大数据集容器。ndarray是一个通用的同构数据多维容器，也就是所有的元素都必须是相同的类型。每个数组都有shape（表示各维度大小的元组）和dtype（表示数组数据类型的对象）。</p>
<div>
<pre class="prettyprint linenums">In[2]: import numpy as np<br />
In[3]: data=[[1,2,3],[4,5,6]]<br />
In[4]: arr=np.array(data)<br />
In[6]: arr<br />
Out[6]:<br />
array([[1, 2, 3],<br />
       [4, 5, 6]])<br />
In[7]: arr.shape<br />
Out[7]: (2L, 3L)<br />
In[8]: arr.dtype<br />
Out[8]: dtype('int32')</pre>
</div>
<p><strong>创建ndarray</strong></p>
<table>
<caption>数组创建函数</caption>
<tbody>
<tr>
<td>函数</td>
<td>说明</td>
</tr>
<tr>
<td>array</td>
<td>将输入数据（列表、元组、数组或其它序列类型）转换为ndarray。要么推断出dtype，要么显示指定dtype。默认直接复制输入数据</td>
</tr>
<tr>
<td>asarray</td>
<td>将输入转换为ndarray，如果输入本身就是一个ndarray就不进行复制</td>
</tr>
<tr>
<td>arange</td>
<td>返回一个ndarray而不是一个列表</td>
</tr>
<tr>
<td>ones、ones_like</td>
<td>根据指定的形状和dtype创建一个全1数组。ones_like以另一个数组为参数，并根据其形状和dtype创建一个全1数组</td>
</tr>
<tr>
<td>zeros、zeros_like</td>
<td>类似于ones和ones_likes只不过产生全0数组</td>
</tr>
<tr>
<td>empty、empty_like</td>
<td>创建新数组，只分配内存空间但不填充任何值</td>
</tr>
<tr>
<td>eye、identity</td>
<td>创建一个N&times;N单位矩阵</td>
</tr>
</tbody>
</table>
<p><strong>ndarray数据类型</strong></p>
<p>int8,int16,int32,int64有符号整型</p>
<p>uint8,uint16,uint32,uint64无符号整型</p>
<p>float16，float32,float64,float128单精度，多精度，扩展精度</p>
<p>complex64,complex128,complex256分别用32,64，128表示的复数</p>
<p>bool</p>
<p>object &nbsp;python数据对象</p>
<p>string_ &nbsp;固定长度的字符串数据类型</p>
<p>unicode_ 固定长度的unicode类型</p>
<div>
<pre class="prettyprint linenums">In[23]: arr.astype(np.float64)<br />
Out[23]: array([ 1.,  2.,  3.,  4.,  5.])<br />
In[27]: h1=arr.astype(np.int16)<br />
In[30]: h1.dtype<br />
Out[30]: dtype('int16')</pre>
</div>
<p><strong>数组和标量之间的运算</strong></p>
<div>
<pre class="prettyprint linenums">In[2]: import numpy as np<br />
In[3]: arr=np.array([[1,2,3],[4,5,6]])<br />
In[4]: arr*arr<br />
Out[4]:<br />
array([[ 1,  4,  9],<br />
       [16, 25, 36]])<br />
In[5]: arr+arr<br />
Out[5]:<br />
array([[ 2,  4,  6],<br />
       [ 8, 10, 12]])<br />
In[6]: arr*4<br />
Out[6]:<br />
array([[ 4,  8, 12],<br />
       [16, 20, 24]])<br />
In[7]: arr**0.5<br />
Out[7]:<br />
array([[ 1.        ,  1.41421356,  1.73205081],<br />
       [ 2.        ,  2.23606798,  2.44948974]])</pre>
</div>
<p><strong>基本的索引和切片</strong></p>
<div>
<pre class="prettyprint linenums">In[8]: np.arange(10)<br />
Out[8]: array([0, 1, 2, 3, 4, 5, 6, 7, 8, 9])<br />
In[9]: arr=np.arange(10)<br />
In[10]: arr[5:8]<br />
Out[10]: array([5, 6, 7])<br />
In[11]: arr_slice=arr[5:8]<br />
In[12]: arr_slice[1]<br />
Out[12]: 6<br />
In[13]: arr_slice[1]=123456<br />
In[14]: arr<br />
Out[14]:<br />
array([     0,      1,      2,      3,      4,      5, 123456,      7,<br />
            8,      9])</pre>
</div>
<p>警告：ndarray切片的一份副本而非视图，就需要显示arr[5:8].copy()</p>
<p><strong>数组的转置与轴对换</strong></p>
<div>
<pre class="prettyprint linenums">In[16]: arr=np.arange(15).reshape((3,5))<br />
In[17]: arr<br />
Out[17]:<br />
array([[ 0,  1,  2,  3,  4],<br />
       [ 5,  6,  7,  8,  9],<br />
       [10, 11, 12, 13, 14]])<br />
In[18]: arr.T<br />
Out[18]:<br />
array([[ 0,  5, 10],<br />
       [ 1,  6, 11],<br />
       [ 2,  7, 12],<br />
       [ 3,  8, 13],<br />
       [ 4,  9, 14]])<br />
In[19]: np.dot(arr,arr.T)<br />
Out[19]:<br />
array([[ 30,  80, 130],<br />
       [ 80, 255, 430],</pre>
</div>
<ul><li><strong>通用函数：快速的元素级数组函数</strong></li></ul>
<ul><li><strong>利用数组进行数据处理</strong></li></ul>
<ul><li><strong>用于数组的文件输入输出</strong></li></ul>
<ul><li><strong>线性代数</strong></li></ul>
<ul><li><strong>随机数生成</strong></li></ul>
<div>
<pre class="prettyprint linenums">In[20]: samples=np.random.normal(size=(4,4))<br />
In[21]: samples<br />
Out[21]:<br />
array([[ 1.2160082 ,  0.34629744, -0.70813727,  2.59673398],<br />
       [-1.32110632,  1.19660352,  0.08227731,  0.24075048],<br />
       [-0.29301216,  0.42639032, -1.76321448, -1.05558718],<br />
       [ 0.0872803 ,  0.25871173,  0.63373105,  0.59362002]])</pre>
</div>
<p>numpy.random模块比python内置的random模块速度更加快。</p>
<p>部分numpy.random函数</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/495pwvqz.html">bzoj1584--DP</a>
		</li>
						<li><a href="https://www.batexi.com/a/39rdeem8.html">&period;htaccess基本语法和应用&nbsp;&lpar;2012-11-09 16&colon;13&colon;47&rpar;转载▼</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqd41ojq.html">bxSlider 在网页里添加幻灯片效果</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyd4r7mq.html">vim中编码方式---不完整总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mdll1q.html">mysql EF</a>
		</li>
						<li><a href="https://www.batexi.com/a/96ok5d39.html">clr介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/95x2n2v8.html">python作业day3修改配置文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmnpje9.html">Python入门-函数的使用到程序的公布安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kz3069.html">sql语句查询数据库中的表名&sol;列名&sol;主键&sol;自动增长值</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zorx11q.html">Core Data使用之一（Swift）： 保存</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mepo50q.html">VS2015下OpenGL库的配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mly1o8.html">LAMP环境跟LNMP环境有什么不同，主要用什么地方</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdoo3z9.html">DevOps之三 Git的安装与配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gewgj08.html">Python--day09（内存管理、垃圾回收机制）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7o2mrg8.html">Fabric 1&period;0交易流程</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjl2pj9.html">CSS cursor 属性改变鼠标的样式</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyvd3k2q.html">OI 助手 &vert; 简洁快速的 OI 工具箱  &lpar;原 竞赛目录生成&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mjeel08.html">两个div如何并列 &lpar;转&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4ppzpeq.html">win7 LR11&period;0 启动controller报：Failed to create Online：无效指针</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o44lzeq.html">matlab中log函数与rssi转距离</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/96p3x7j8.html">后台验证url是不是有效的链接</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy1vm5jq.html">苹果dock效果</a>
			</li>
						<li><a href="https://www.batexi.com/a/90m2o0m8.html">FTP服务添加用户及设置权限</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxk206d8.html">jquery&period;cookie&period;js 的配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zok5m3q.html">poj 2299 Ultra-QuickSort 逆序对模版题</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnjdmvj8.html">php基础的第一天  任务点滴&comma;event对象方法概括  ing&period;&period;&period;&period;</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rg4zwd8.html">chapter 13&lowbar;0 元方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy12wojq.html">redhat 时区修改</a>
			</li>
						<li><a href="https://www.batexi.com/a/96pmojn8.html">Developing a Custom Membership Provider from the scratch&comma; and using it in the FBA &lpar;Form Based Authentication&rpar; in SharePoint 2010</a>
			</li>
						<li><a href="https://www.batexi.com/a/9ge3p3z8.html">c&sol;s架构</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
